"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSlotNames = getSlotNames;
const language_core_1 = require("@vue/language-core");
function getSlotNames(fileName) {
    const { typescript: ts, language, languageService, getFileId } = this;
    const sourceScript = language.scripts.get(getFileId(fileName));
    if (!sourceScript?.generated) {
        return;
    }
    const root = sourceScript.generated.root;
    if (!(root instanceof language_core_1.VueVirtualCode)) {
        return;
    }
    const program = languageService.getProgram();
    const tsSourceFile = program.getSourceFile(fileName);
    if (!tsSourceFile) {
        return;
    }
    const checker = program.getTypeChecker();
    const typeNode = tsSourceFile.statements
        .filter(ts.isTypeAliasDeclaration)
        .find(node => node.name.getText() === '__VLS_Slots');
    if (typeNode) {
        const attrs = checker.getTypeFromTypeNode(typeNode.type).getProperties();
        return attrs.map(attr => attr.name);
    }
    return [];
}
//# sourceMappingURL=getSlotNames.js.map