"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.goToDefinition = goToDefinition;
const vue = require("@vue/language-core");
const componentInfos_1 = require("./componentInfos");
function goToDefinition(fileName, tag) {
    const { typescript: ts, language, languageService, getFileId } = this;
    const volarFile = language.scripts.get(getFileId(fileName));
    if (!(volarFile?.generated?.root instanceof vue.VueVirtualCode)) {
        return;
    }
    const vueCode = volarFile.generated.root;
    const components = (0, componentInfos_1.getVariableType)(ts, languageService, vueCode, '__VLS_components');
    if (!components) {
        return '';
    }
    const componentType = (0, componentInfos_1.getComponentType)(ts, languageService, vueCode, components, fileName, tag);
    if (!componentType) {
        return '';
    }
    const decls = componentType.symbol.declarations ?? [];
    for (const decl of decls) {
        return decl.getSourceFile().fileName;
    }
}
//# sourceMappingURL=goToDefinition.js.map